package com.zhongzheng.modules.recruit.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.recruit.bo.RecruitAttachResumeAddBo;
import com.zhongzheng.modules.recruit.bo.RecruitAttachResumeEditBo;
import com.zhongzheng.modules.recruit.bo.RecruitAttachResumeQueryBo;
import com.zhongzheng.modules.recruit.domain.RecruitAttachResume;
import com.zhongzheng.modules.recruit.mapper.RecruitAttachResumeMapper;
import com.zhongzheng.modules.recruit.service.IRecruitAttachResumeService;
import com.zhongzheng.modules.recruit.vo.RecruitAttachResumeVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 附件简历Service业务层处理
 *
 * @author hjl
 * @date 2021-08-20
 */
@Service
public class RecruitAttachResumeServiceImpl extends ServiceImpl<RecruitAttachResumeMapper, RecruitAttachResume> implements IRecruitAttachResumeService {

    @Override
    public RecruitAttachResumeVo queryById(Long attachResumeId){
        RecruitAttachResume db = this.baseMapper.selectById(attachResumeId);
        return BeanUtil.toBean(db, RecruitAttachResumeVo.class);
    }

    @Override
    public List<RecruitAttachResumeVo> queryList(RecruitAttachResumeQueryBo bo) {
        LambdaQueryWrapper<RecruitAttachResume> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getUserId() != null, RecruitAttachResume::getUserId, bo.getUserId());
        lqw.like(StrUtil.isNotBlank(bo.getAttachName()), RecruitAttachResume::getAttachName, bo.getAttachName());
        lqw.eq(StrUtil.isNotBlank(bo.getAttachUrl()), RecruitAttachResume::getAttachUrl, bo.getAttachUrl());
        lqw.eq(bo.getStatus() != null, RecruitAttachResume::getStatus, bo.getStatus());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<RecruitAttachResumeVo> entity2Vo(Collection<RecruitAttachResume> collection) {
        List<RecruitAttachResumeVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, RecruitAttachResumeVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<RecruitAttachResume> page = (Page<RecruitAttachResume>)collection;
            Page<RecruitAttachResumeVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(RecruitAttachResumeAddBo bo) {
        RecruitAttachResume add = BeanUtil.toBean(bo, RecruitAttachResume.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(RecruitAttachResumeEditBo bo) {
        RecruitAttachResume update = BeanUtil.toBean(bo, RecruitAttachResume.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(RecruitAttachResume entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
